#include "declarations.h"   


int main(int argc, char *argv[])
{
   g_snprintf(gCat_dir, sizeof(gCat_dir), "%s/.gCatalog", getenv("HOME"));
   g_snprintf(tempfile, sizeof(tempfile), "%s/tempfile.itm", gCat_dir);
   g_snprintf(pasteQ, sizeof(pasteQ), "%s/paste.Q", gCat_dir);

   directory_stuff();

   black.red = 0;
   black.green = 0;
   black.blue = 0;
   red.red = 65535;
   red.green = 0;
   red.blue = 0;
   green.red = 0;
   green.green = 65535;
   green.blue = 0;
   blue.red = 0;
   blue.green = 0;
   blue.blue = 65535;
   
   gnome_init("gCatalog", VERSION, argc, argv);

/* initialize the window and give it a name and a size */

   window = gnome_app_new("gCatalog", "gCatalog v" VERSION );
   gtk_container_set_border_width(GTK_CONTAINER(window), 10);

/* this stuff is apparently for the window manager */
   gtk_signal_connect(GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC(destroy), NULL);
   gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(destroy), NULL);
   
   make_menus();
   make_toolbar();

   app_bar = gnome_appbar_new(TRUE, TRUE, GNOME_PREFERENCES_NEVER);
   gtk_widget_ref (app_bar);
   gtk_widget_show (app_bar);
   gnome_app_set_statusbar(GNOME_APP(window), app_bar);

   whole_window_box = gtk_vbox_new(FALSE, 0);
   gnome_app_set_contents(GNOME_APP(window), whole_window_box);
   gtk_widget_show(whole_window_box);

   mdi_book = gtk_notebook_new ();
   gtk_notebook_set_tab_pos(GTK_NOTEBOOK(mdi_book), GTK_POS_TOP);
   gtk_box_pack_start (GTK_BOX(whole_window_box), mdi_book, TRUE, TRUE, 5);
   gtk_signal_connect(GTK_OBJECT(mdi_book), "switch_page", GTK_SIGNAL_FUNC(set_notebook_page), NULL);  
   gtk_widget_show(mdi_book);

   get_prefs();
   add_new_file("Untitled", FALSE);
   flush_file(tempfile);
   gtk_widget_show(window);
   gtk_main();
}


void add_new_file(gchar *filename, gboolean fill)
{
   struct opened_file *new_file;
   new_file = new opened_file;
   file_list[total_files] = new_file;
   strcpy(new_file->filename, filename);
   g_snprintf(new_file->tempfile, sizeof(new_file->tempfile), "%s/temp%d.itm", gCat_dir, maximum_files);   
   flush_file(new_file->tempfile);
   g_snprintf(new_file->undofile, sizeof(new_file->tempfile), "%s/temp%d.undo", gCat_dir, maximum_files);   
   flush_file(new_file->undofile);
   new_file->saved = TRUE;
   new_file->undo = FALSE;
   new_file->cur_selected_node = NULL;
   
   new_file->notebook_box = gtk_vbox_new(FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(new_file->notebook_box), 10);
   gtk_widget_show(new_file->notebook_box);
   new_file->notebook_label = gtk_label_new(new_file->filename);
   gtk_widget_show(new_file->notebook_label);
   new_file->notebook_label = gtk_label_new(new_file->filename);
   
   new_file->table = gtk_table_new(5, 4, TRUE);
   gtk_box_pack_start(GTK_BOX(new_file->notebook_box), new_file->table, TRUE, TRUE, 0); 
   gtk_widget_show(new_file->table);
   
   new_file->tree_window = gtk_scrolled_window_new(0, 0);
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(new_file->tree_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
   gtk_table_attach(GTK_TABLE(new_file->table), new_file->tree_window, 0, 1, 0, 5, GTK_FILL, GTK_FILL, 0, 0);
   gtk_widget_show(new_file->tree_window);

   new_file->tree_widget = gtk_ctree_new(1, 0);
   gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(new_file->tree_window), new_file->tree_widget);
   gtk_signal_connect(GTK_OBJECT(new_file->tree_widget), "tree_select_row", GTK_SIGNAL_FUNC(show_selected_item), 0);
   gtk_signal_connect(GTK_OBJECT(new_file->tree_widget), "tree_unselect_row", GTK_SIGNAL_FUNC(unshow_selected_item), 0);
   gtk_widget_show(new_file->tree_widget);

   new_file->image_box = gtk_vbox_new(TRUE, 0);
   gtk_table_attach(GTK_TABLE(new_file->table), new_file->image_box, 1, 4, 0, 3, GTK_FILL, GTK_FILL, 0, 0);
   gtk_widget_show(new_file->image_box);

   new_file->pixmapwid = gnome_pixmap_new_from_file(aboutimage_filename);
   gtk_box_pack_start(GTK_BOX(new_file->image_box), new_file->pixmapwid, FALSE, FALSE, 5);
   gtk_widget_show(new_file->pixmapwid);

   new_file->main_box = gtk_hbox_new(FALSE, 0);
   gtk_table_attach(GTK_TABLE(new_file->table), new_file->main_box, 1, 4, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
   gtk_widget_show(new_file->main_box);

   new_file->item_text = gtk_text_new(0, 0);
   gtk_widget_set_usize(GTK_WIDGET(new_file->item_text), 570, 100);
   gtk_box_pack_start(GTK_BOX(new_file->main_box), new_file->item_text, TRUE, TRUE, 0);
   new_file->item_scroller = gtk_vscrollbar_new(GTK_TEXT(new_file->item_text)->vadj);
   gtk_box_pack_start(GTK_BOX(new_file->main_box), new_file->item_scroller, FALSE, FALSE, 0);
   gtk_text_set_editable(GTK_TEXT(new_file->item_text), FALSE);
   gtk_widget_show(new_file->item_text);
   gtk_widget_show(new_file->item_scroller);

   new_file->props_box = gtk_hbox_new(FALSE, 0);
   gtk_table_attach(GTK_TABLE(new_file->table), new_file->props_box, 1, 4, 4, 5, GTK_FILL, GTK_FILL, 0, 0);
   gtk_widget_show(new_file->props_box);
   
   new_file->item_list_window = gtk_scrolled_window_new (0, 0);
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(new_file->item_list_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
   gtk_box_pack_start(GTK_BOX(new_file->props_box), new_file->item_list_window, TRUE, TRUE, 0);
   gtk_widget_show(new_file->item_list_window);

   new_file->item_list = gtk_clist_new(2);
   gtk_clist_set_column_title(GTK_CLIST(new_file->item_list), 0, "Item");
   gtk_clist_set_column_title(GTK_CLIST(new_file->item_list), 1, "Value");
   gtk_clist_set_selection_mode(GTK_CLIST(new_file->item_list), GTK_SELECTION_SINGLE);
   gtk_clist_set_shadow_type(GTK_CLIST(new_file->item_list), GTK_SHADOW_ETCHED_IN);
   gtk_clist_set_column_justification(GTK_CLIST(new_file->item_list), 0, GTK_JUSTIFY_LEFT);
   gtk_clist_set_row_height(GTK_CLIST(new_file->item_list), 15);
   gtk_container_add(GTK_CONTAINER(new_file->item_list_window), new_file->item_list);
   gtk_clist_column_titles_show(GTK_CLIST(new_file->item_list));
   gtk_clist_set_column_width (GTK_CLIST(new_file->item_list), 0, 100);
   gtk_widget_show(new_file->item_list);

   cur_file = new_file;
   total_files++;
   maximum_files++;
   gtk_notebook_append_page(GTK_NOTEBOOK(mdi_book), new_file->notebook_box, new_file->notebook_label);
   gtk_notebook_set_page(GTK_NOTEBOOK(mdi_book), total_files - 1);

   set_window_title();
   if(fill == TRUE)
   {
      copy_file(new_file->filename, new_file->tempfile);
      make_tree(cur_file->tree_widget, cur_file->tempfile);
   }
   adjust_sensitivity();   
}


void set_notebook_page(GtkNotebook *notebook, GtkNotebookPage *page, guint page_num, gpointer *data)
{
   cur_file = file_list[page_num];
   cur_page = page_num;
   set_window_title();
   adjust_sensitivity();
}


void show_selected_item(GtkWidget *widget, GtkCTreeNode *node, gint column, gpointer data)
{
   cur_file->cur_selected_node = node;
   gtk_ctree_expand(GTK_CTREE(cur_file->tree_widget), node);
   gtk_editable_delete_text(GTK_EDITABLE(cur_file->item_text), 0, -1);
   gtk_clist_clear(GTK_CLIST(cur_file->item_list));
   build_props(cur_file->item_list, cur_file->item_text, cur_file->tempfile);
   adjust_sensitivity();   
   display_image(cur_file->image_str);
}

    
void unshow_selected_item( GtkWidget *widget, GtkCTreeNode *node, gint column, gpointer data)
{
   gtk_editable_delete_text(GTK_EDITABLE(cur_file->item_text), 0, -1);
   cur_file->cur_selected_node = NULL;
   adjust_sensitivity();
   gtk_clist_clear(GTK_CLIST(cur_file->item_list));
   cur_file->image_str[0] = '\0';
   display_image(cur_file->image_str);
}


void build_props(GtkWidget *clist, GtkWidget *text, gchar *filename)
{
   cur_file->image_str[0] = '\0';
   total_props = 0;

   char input[1024];
   char buffer[256] = "";
   char *char_ptr;

   ifstream Input;
   Input.open(filename);

   gchar *tree_text;

   gtk_ctree_node_get_pixtext(GTK_CTREE(cur_file->tree_widget), cur_file->cur_selected_node, 0, &tree_text, NULL, NULL, NULL);

   strcat(buffer, "name=[");
   strcat(buffer, tree_text);
   strcat(buffer, "]");

   while(Input.getline(input, 1024) != NULL)
   {
      if((strstr(input, buffer)) == NULL)
         continue;

      if((char_ptr = strstr(input, "image=[")) != NULL)
      {
         char_ptr += 7;
	 if(*char_ptr != ']')
	 {
            copy_chars(char_ptr, cur_file->image_str, 256);
	 }
      }

      char *cur_ptr = input;
      while((cur_ptr = strchr(cur_ptr, ' ')) != NULL)
      {
	 cur_ptr++;
	 item_ptrs[0] = cur_ptr;
         while((*cur_ptr != '=') && (*cur_ptr != '\0'))
	    cur_ptr++;

         if(*cur_ptr == '\0')
	    break;
	    
         *cur_ptr = '\0';
         cur_ptr++; cur_ptr++;
	 item_ptrs[1] = cur_ptr;

         while((*cur_ptr != ']') && (*cur_ptr != '\0'))
	    cur_ptr++;
         if(*cur_ptr != '\0')
	 {
            *cur_ptr = '\0';
            cur_ptr++;
            gtk_clist_append(GTK_CLIST(clist), item_ptrs); 
            total_props++;
         }
         else
	 {
	    break;
	 }
      }
      while((Input.getline(input, 1024)) != NULL)
      {
         if((strstr(input, "Tree")) != NULL)
            break;
         strcat(input, "\n");        
         gtk_text_insert(GTK_TEXT(text), 0, &black, 0, input, -1);
      }
      break;
   }
   Input.close();
}


void adjust_sensitivity()
{

   if(cur_file == NULL)
   {
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_close), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_close_button), 0);      
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_new), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_new_button), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_open), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_open_button), 1);      
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_save), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_save_button), 0);      
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_saveas), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_saveas_button), 0);      
      gtk_widget_set_sensitive(GTK_WIDGET(editmenu), 0);
      return;
   }

   // File Menus
   if(total_files >= MAX_FILES)
   {
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_new), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_new_button), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_open), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_open_button), 0);      
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_new), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_new_button), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_open), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_open_button), 1);      
   }

   gtk_widget_set_sensitive(GTK_WIDGET(file_menu_close), 1);
   gtk_widget_set_sensitive(GTK_WIDGET(toolbar_close_button), 1);      

   if(cur_file->saved == FALSE)
   {
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_save), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_save_button), 1);      
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(file_menu_save), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_save_button), 0);      
   }

   gtk_widget_set_sensitive(GTK_WIDGET(file_menu_saveas), 1);
   gtk_widget_set_sensitive(GTK_WIDGET(toolbar_saveas_button), 1);      

   // Edit Menus
   if(cur_prefs[ALLOW_EDIT] == TRUE)
   {
      gtk_widget_set_sensitive(GTK_WIDGET(editmenu), 1);   
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(editmenu), 0);   
   }
   
   if((cur_file->undo == TRUE))
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_undo), 1);
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_undo), 0);
   }
   
   if((cur_file->cur_selected_node != NULL))
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_cut), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_copy), 1);
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_cut), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_copy), 0);      
   }

   if((paste_ok == TRUE))
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_paste), 1);
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_paste), 0);
   }

   if((cur_prefs[ALLOW_EDIT] == TRUE) && (cur_file->cur_selected_node != NULL))
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_change_desc), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_change_img), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newcat), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newitem), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 1);
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_change_desc), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_change_img), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newcat), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newitem), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 0);
   }
   
   if((cur_prefs[SHOW_PROPS] == TRUE) && (cur_file->cur_selected_node != NULL))
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_edit_props), 1);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_properties_button), 1);
   }
   else
   {
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_edit_props), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(toolbar_properties_button), 0);	    	 
   }

   adjust_props();
}


void adjust_props()
{
   if((cur_prefs[SHOW_PROPS] == FALSE) || (cur_file->cur_selected_node == NULL))
   {
      if(GTK_IS_CLIST(cur_file->item_list))
      {
         gtk_clist_clear(GTK_CLIST(cur_file->item_list));
         gtk_widget_set_sensitive(cur_file->props_box, 0);
      }
   }
   else
   {
      gtk_widget_set_sensitive(cur_file->props_box, 1);
   }
   return;   
}


void display_image(gchar *image_name)
{
   kill_widget(cur_file->pixmapwid, cur_file->pixmapwid);
   if((*image_name != '\0') && (image_name != NULL))
   {
      if((cur_file->cur_selected_node != NULL) && (cur_prefs[SHOW_IMAGES] == TRUE))
      {
         cur_file->pixmapwid = gnome_pixmap_new_from_file(image_name);
         if(cur_file->pixmapwid == NULL)   
            cur_file->pixmapwid = gnome_pixmap_new_from_file(noimage_filename);
         gtk_box_pack_start(GTK_BOX(cur_file->image_box), cur_file->pixmapwid, FALSE, FALSE, 5);
         gtk_widget_show(cur_file->pixmapwid);
         return;
      }
   }
   cur_file->pixmapwid = gnome_pixmap_new_from_file(noimage_filename);
   gtk_box_pack_start(GTK_BOX(cur_file->image_box), cur_file->pixmapwid, FALSE, FALSE, 5);
   gtk_widget_show(cur_file->pixmapwid);
}


void copy_chars(char *source, char *dest, int max_chars)
{
   char cur_char;
   for(int iterations = 0; iterations < max_chars; iterations++)
   {
      cur_char = *source;
      *dest = cur_char;
      if(cur_char == ']' || cur_char == '\0' || cur_char == '=')
      {
         *dest = '\0';
         break;
      }
      source++;
      dest++;
   }
}


void set_window_title()
{
   char buffer[256] = "gCatalog v" VERSION " - ";
   strcat(buffer, cur_file->filename);
   gtk_window_set_title(&GNOME_APP(window)->parent_object, buffer);
}


void flush_file(gchar *name)
{
   ofstream Output;
   Output.open(name);
   Output.close();
}


void directory_stuff()
{
   char buffer[256] = "";
   strcat(buffer, gCat_dir);
   strcat(buffer, "/gCatalog.conf");
   ifstream Input;
   Input.open(buffer);
   if(!Input)
   {
      cout << "Creating " << buffer << " ..." << endl;
      char dirbuffer[256] = "mkdir ";
      strcat(dirbuffer, gCat_dir);
      system(dirbuffer);
      save_prefs(FALSE);
   }
   Input.close();
}


void kill_widget(GtkWidget *widget, GtkWidget *target)
{
   gtk_widget_destroy(GTK_WIDGET(target));
}


gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
   return(TRUE);
}


void destroy(GtkWidget *widget, gpointer data)
{
   gtk_main_quit();
}
